Index: c/src/lib/libbsp/arm/altera-cyclone-v/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/arm/altera-cyclone-v/startup/bspstart.c	(revision 707ecbe4ec1018521b222fc374ac6748099574ff)
+++ c/src/lib/libbsp/arm/altera-cyclone-v/startup/bspstart.c	(revision bc820946793426dbdc450dc8bba4a15d01006182)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2013-2014 embedded brains GmbH.  All rights reserved.
+ * Copyright (c) 2013-2015 embedded brains GmbH.  All rights reserved.
  *
  *  embedded brains GmbH
@@ -23,6 +23,6 @@
   bsp_interrupt_initialize();
   rtems_cache_coherent_add_area(
-    bsp_nocache_heap_begin,
-    (uintptr_t) bsp_nocache_heap_size
+    bsp_section_nocacheheap_begin,
+    (uintptr_t) bsp_section_nocacheheap_size
   );
 }
Index: c/src/lib/libbsp/arm/shared/include/linker-symbols.h
===================================================================
--- c/src/lib/libbsp/arm/shared/include/linker-symbols.h	(revision 707ecbe4ec1018521b222fc374ac6748099574ff)
+++ c/src/lib/libbsp/arm/shared/include/linker-symbols.h	(revision bc820946793426dbdc450dc8bba4a15d01006182)
@@ -8,5 +8,5 @@
 
 /*
- * Copyright (c) 2008-2014 embedded brains GmbH.  All rights reserved.
+ * Copyright (c) 2008-2015 embedded brains GmbH.  All rights reserved.
  *
  *  embedded brains GmbH
@@ -120,4 +120,8 @@
 LINKER_SYMBOL(bsp_section_nocache_load_end)
 
+LINKER_SYMBOL(bsp_section_nocacheheap_begin)
+LINKER_SYMBOL(bsp_section_nocacheheap_end)
+LINKER_SYMBOL(bsp_section_nocacheheap_size)
+
 LINKER_SYMBOL(bsp_vector_table_begin)
 LINKER_SYMBOL(bsp_vector_table_end)
@@ -130,8 +134,4 @@
 LINKER_SYMBOL(bsp_translation_table_base)
 LINKER_SYMBOL(bsp_translation_table_end)
-
-LINKER_SYMBOL(bsp_nocache_heap_begin)
-LINKER_SYMBOL(bsp_nocache_heap_end)
-LINKER_SYMBOL(bsp_nocache_heap_size)
 
 #define BSP_FAST_TEXT_SECTION __attribute__((section(".bsp_fast_text")))
Index: c/src/lib/libbsp/arm/shared/startup/linkcmds.base
===================================================================
--- c/src/lib/libbsp/arm/shared/startup/linkcmds.base	(revision 707ecbe4ec1018521b222fc374ac6748099574ff)
+++ c/src/lib/libbsp/arm/shared/startup/linkcmds.base	(revision bc820946793426dbdc450dc8bba4a15d01006182)
@@ -8,8 +8,8 @@
 
 /*
- * Copyright (c) 2008-2014 embedded brains GmbH.  All rights reserved.
+ * Copyright (c) 2008-2015 embedded brains GmbH.  All rights reserved.
  *
  *  embedded brains GmbH
- *  Obere Lagerstr. 30
+ *  Dornierstr. 4
  *  82178 Puchheim
  *  Germany
@@ -401,13 +401,16 @@
 		bsp_section_nocache_begin = .;
 		*(SORT(.bsp_nocache*))
-		bsp_nocache_heap_begin = .;
-		. += ORIGIN (REGION_NOCACHE) + LENGTH (REGION_NOCACHE) - ABSOLUTE (.);
-		bsp_nocache_heap_end = .;
 		bsp_section_nocache_end = .;
 	} > REGION_NOCACHE AT > REGION_NOCACHE_LOAD
-	bsp_nocache_heap_size = bsp_nocache_heap_end - bsp_nocache_heap_begin;
 	bsp_section_nocache_size = bsp_section_nocache_end - bsp_section_nocache_begin;
 	bsp_section_nocache_load_begin = LOADADDR (.nocache);
 	bsp_section_nocache_load_end = bsp_section_nocache_load_begin + bsp_section_nocache_size;
+
+	.nocacheheap (NOLOAD) : ALIGN_WITH_INPUT {
+		bsp_section_nocacheheap_begin = .;
+		. += ORIGIN (REGION_NOCACHE) + LENGTH (REGION_NOCACHE) - ABSOLUTE (.);
+		bsp_section_nocacheheap_end = .;
+	} > REGION_NOCACHE AT > REGION_NOCACHE
+	bsp_section_nocacheheap_size = bsp_section_nocacheheap_end - bsp_section_nocacheheap_begin;
 
 	/* FIXME */
Index: c/src/lib/libbsp/arm/xilinx-zynq/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/arm/xilinx-zynq/startup/bspstart.c	(revision 707ecbe4ec1018521b222fc374ac6748099574ff)
+++ c/src/lib/libbsp/arm/xilinx-zynq/startup/bspstart.c	(revision bc820946793426dbdc450dc8bba4a15d01006182)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2013-2014 embedded brains GmbH.  All rights reserved.
+ * Copyright (c) 2013-2015 embedded brains GmbH.  All rights reserved.
  *
  *  embedded brains GmbH
@@ -29,6 +29,6 @@
   bsp_interrupt_initialize();
   rtems_cache_coherent_add_area(
-    bsp_nocache_heap_begin,
-    (uintptr_t) bsp_nocache_heap_size
+    bsp_section_nocacheheap_begin,
+    (uintptr_t) bsp_section_nocacheheap_size
   );
 }
Index: c/src/lib/libbsp/powerpc/shared/include/linker-symbols.h
===================================================================
--- c/src/lib/libbsp/powerpc/shared/include/linker-symbols.h	(revision 707ecbe4ec1018521b222fc374ac6748099574ff)
+++ c/src/lib/libbsp/powerpc/shared/include/linker-symbols.h	(revision bc820946793426dbdc450dc8bba4a15d01006182)
@@ -8,8 +8,8 @@
 
 /*
- * Copyright (c) 2010-2013 embedded brains GmbH.  All rights reserved.
+ * Copyright (c) 2010-2015 embedded brains GmbH.  All rights reserved.
  *
  *  embedded brains GmbH
- *  Donrierstr. 4
+ *  Dornierstr. 4
  *  82178 Puchheim
  *  Germany
@@ -100,4 +100,8 @@
 LINKER_SYMBOL(bsp_section_nocache_load_end)
 
+LINKER_SYMBOL(bsp_section_nocacheheap_begin)
+LINKER_SYMBOL(bsp_section_nocacheheap_end)
+LINKER_SYMBOL(bsp_section_nocacheheap_size)
+
 LINKER_SYMBOL(bsp_section_nvram_begin)
 LINKER_SYMBOL(bsp_section_nvram_end)
Index: c/src/lib/libbsp/powerpc/shared/startup/linkcmds.base
===================================================================
--- c/src/lib/libbsp/powerpc/shared/startup/linkcmds.base	(revision 707ecbe4ec1018521b222fc374ac6748099574ff)
+++ c/src/lib/libbsp/powerpc/shared/startup/linkcmds.base	(revision bc820946793426dbdc450dc8bba4a15d01006182)
@@ -8,8 +8,8 @@
 
 /*
- * Copyright (c) 2011-2013 embedded brains GmbH.  All rights reserved.
+ * Copyright (c) 2011-2015 embedded brains GmbH.  All rights reserved.
  *
  *  embedded brains GmbH
- *  Obere Lagerstr. 30
+ *  Dornierstr. 4
  *  82178 Puchheim
  *  Germany
@@ -343,9 +343,16 @@
 	bsp_section_nocache_load_end = bsp_section_nocache_load_begin + bsp_section_nocache_size;
 
+	.nocacheheap (NOLOAD) : ALIGN_WITH_INPUT {
+		bsp_section_nocacheheap_begin = .;
+		. += ORIGIN (REGION_NOCACHE) + LENGTH (REGION_NOCACHE) - ABSOLUTE (.);
+		bsp_section_nocacheheap_end = .;
+	} > REGION_NOCACHE AT > REGION_NOCACHE
+	bsp_section_nocacheheap_size = bsp_section_nocacheheap_end - bsp_section_nocacheheap_begin;
+
 	.nvram (NOLOAD) : ALIGN_WITH_INPUT {
 		bsp_section_nvram_begin = .;
 		*(SORT(.bsp_nvram*))
 		bsp_section_nvram_end = .;
-	} > REGION_NVRAM
+	} > REGION_NVRAM AT > REGION_NVRAM
 	bsp_section_nvram_size = bsp_section_nvram_end - bsp_section_nvram_begin;
 
